#include <stdio.h>
#include <stdint.h>
#include <inttypes.h>

#include "yices.h"

int main(void) {
  yices_init();

  term_t hundred = yices_int32(100);
  term_t p = yices_new_uninterpreted_term(yices_real_type());
  yices_set_term_name(p, "x");
  p = yices_mul(hundred, p);

  yices_pp_term(stdout, p, 10, 100, 0);
  term_constructor_t constructor = yices_term_constructor(p);
  uint32_t n = yices_term_num_children(p);

  switch (constructor) {
  case YICES_ARITH_SUM:
    printf("Constructor = YICES_ARITH_SUM: %"PRIu32" children\n", n);
    break;

  case YICES_POWER_PRODUCT:
    printf("Constructor = YICES_ARITH_SUM: %"PRIu32" children\n", n);
    break;

  default:
    printf("Some other constructor (%"PRId32")  %"PRIu32" children\n", (int32_t) constructor, n);
    break;
  }

  yices_exit();

  return 0;
}
